# This file was generated by PythonNetStubGenerator
# mypy: ignore-errors
import typing, clr, abc
from System import Attribute, Array, Array_1, IDisposable, SystemException, Exception
from System.Collections import ICollection, IEnumerator, Hashtable, ArrayList, IDictionary
from System.Runtime.Serialization import IDeserializationCallback, SerializationInfo, StreamingContext
from System.Security.Permissions import PermissionState
from System.Reflection import AssemblyName, MethodInfo, MethodBase

class AllowPartiallyTrustedCallersAttribute(Attribute):
    def __init__(self) -> None: ...
    @property
    def PartialTrustVisibilityLevel(self) -> PartialTrustVisibilityLevel: ...
    @PartialTrustVisibilityLevel.setter
    def PartialTrustVisibilityLevel(self, value: PartialTrustVisibilityLevel) -> PartialTrustVisibilityLevel: ...
    @property
    def TypeId(self) -> typing.Any: ...


class IPermission(ISecurityEncodable, typing.Protocol):
    @abc.abstractmethod
    def Copy(self) -> IPermission: ...
    @abc.abstractmethod
    def Demand(self) -> None: ...
    @abc.abstractmethod
    def Intersect(self, target: typing.Optional[IPermission]) -> typing.Optional[IPermission]: ...
    @abc.abstractmethod
    def IsSubsetOf(self, target: typing.Optional[IPermission]) -> bool: ...
    @abc.abstractmethod
    def Union(self, target: typing.Optional[IPermission]) -> typing.Optional[IPermission]: ...


class ISecurityEncodable(typing.Protocol):
    @abc.abstractmethod
    def FromXml(self, e: SecurityElement) -> None: ...
    @abc.abstractmethod
    def ToXml(self) -> typing.Optional[SecurityElement]: ...


class IStackWalk(typing.Protocol):
    @abc.abstractmethod
    def Assert(self) -> None: ...
    @abc.abstractmethod
    def Demand(self) -> None: ...
    @abc.abstractmethod
    def Deny(self) -> None: ...
    @abc.abstractmethod
    def PermitOnly(self) -> None: ...


class PartialTrustVisibilityLevel(typing.SupportsInt):
    @typing.overload
    def __init__(self, value : int) -> None: ...
    @typing.overload
    def __init__(self, value : int, force_if_true: bool) -> None: ...
    def __int__(self) -> int: ...
    
    # Values:
    VisibleToAllHosts : PartialTrustVisibilityLevel # 0
    NotVisibleByDefault : PartialTrustVisibilityLevel # 1


class PermissionSet(ICollection, IStackWalk, ISecurityEncodable, IDeserializationCallback):
    @typing.overload
    def __init__(self, permSet: typing.Optional[PermissionSet]) -> None: ...
    @typing.overload
    def __init__(self, state: PermissionState) -> None: ...
    @property
    def Count(self) -> int: ...
    @property
    def IsReadOnly(self) -> bool: ...
    @property
    def IsSynchronized(self) -> bool: ...
    @property
    def SyncRoot(self) -> typing.Any: ...
    def AddPermission(self, perm: typing.Optional[IPermission]) -> typing.Optional[IPermission]: ...
    def Assert(self) -> None: ...
    def ContainsNonCodeAccessPermissions(self) -> bool: ...
    @staticmethod
    def ConvertPermissionSet(inFormat: str, inData: Array_1[int], outFormat: str) -> Array_1[int]: ...
    def Copy(self) -> PermissionSet: ...
    def CopyTo(self, array: Array, index: int) -> None: ...
    def Demand(self) -> None: ...
    def Deny(self) -> None: ...
    def Equals(self, o: typing.Optional[typing.Any]) -> bool: ...
    def FromXml(self, et: SecurityElement) -> None: ...
    def GetEnumerator(self) -> IEnumerator: ...
    def GetHashCode(self) -> int: ...
    def GetPermission(self, permClass: typing.Optional[typing.Type[typing.Any]]) -> typing.Optional[IPermission]: ...
    def Intersect(self, other: typing.Optional[PermissionSet]) -> typing.Optional[PermissionSet]: ...
    def IsEmpty(self) -> bool: ...
    def IsSubsetOf(self, target: typing.Optional[PermissionSet]) -> bool: ...
    def IsUnrestricted(self) -> bool: ...
    def PermitOnly(self) -> None: ...
    def RemovePermission(self, permClass: typing.Optional[typing.Type[typing.Any]]) -> typing.Optional[IPermission]: ...
    @staticmethod
    def RevertAssert() -> None: ...
    def SetPermission(self, perm: typing.Optional[IPermission]) -> typing.Optional[IPermission]: ...
    def ToString(self) -> str: ...
    def ToXml(self) -> typing.Optional[SecurityElement]: ...
    def Union(self, other: typing.Optional[PermissionSet]) -> typing.Optional[PermissionSet]: ...


class SecureString(IDisposable):
    @typing.overload
    def __init__(self) -> None: ...
    @typing.overload
    def __init__(self, value: clr.Reference[str], length: int) -> None: ...
    @property
    def Length(self) -> int: ...
    def AppendChar(self, c: str) -> None: ...
    def Clear(self) -> None: ...
    def Copy(self) -> SecureString: ...
    def Dispose(self) -> None: ...
    def InsertAt(self, index: int, c: str) -> None: ...
    def IsReadOnly(self) -> bool: ...
    def MakeReadOnly(self) -> None: ...
    def RemoveAt(self, index: int) -> None: ...
    def SetAt(self, index: int, c: str) -> None: ...


class SecurityCriticalAttribute(Attribute):
    @typing.overload
    def __init__(self) -> None: ...
    @typing.overload
    def __init__(self, scope: SecurityCriticalScope) -> None: ...
    @property
    def Scope(self) -> SecurityCriticalScope: ...
    @property
    def TypeId(self) -> typing.Any: ...


class SecurityCriticalScope(typing.SupportsInt):
    @typing.overload
    def __init__(self, value : int) -> None: ...
    @typing.overload
    def __init__(self, value : int, force_if_true: bool) -> None: ...
    def __int__(self) -> int: ...
    
    # Values:
    Explicit : SecurityCriticalScope # 0
    Everything : SecurityCriticalScope # 1


class SecurityElement:
    @typing.overload
    def __init__(self, tag: str) -> None: ...
    @typing.overload
    def __init__(self, tag: str, text: typing.Optional[str]) -> None: ...
    @property
    def Attributes(self) -> typing.Optional[Hashtable]: ...
    @Attributes.setter
    def Attributes(self, value: typing.Optional[Hashtable]) -> typing.Optional[Hashtable]: ...
    @property
    def Children(self) -> typing.Optional[ArrayList]: ...
    @Children.setter
    def Children(self, value: typing.Optional[ArrayList]) -> typing.Optional[ArrayList]: ...
    @property
    def Tag(self) -> str: ...
    @Tag.setter
    def Tag(self, value: str) -> str: ...
    @property
    def Text(self) -> typing.Optional[str]: ...
    @Text.setter
    def Text(self, value: typing.Optional[str]) -> typing.Optional[str]: ...
    def AddAttribute(self, name: str, value: str) -> None: ...
    def AddChild(self, child: SecurityElement) -> None: ...
    def Attribute(self, name: str) -> typing.Optional[str]: ...
    def Copy(self) -> SecurityElement: ...
    def Equal(self, other: typing.Optional[SecurityElement]) -> bool: ...
    @staticmethod
    def Escape(str: typing.Optional[str]) -> typing.Optional[str]: ...
    @staticmethod
    def FromString(xml: str) -> typing.Optional[SecurityElement]: ...
    @staticmethod
    def IsValidAttributeName(name: typing.Optional[str]) -> bool: ...
    @staticmethod
    def IsValidAttributeValue(value: typing.Optional[str]) -> bool: ...
    @staticmethod
    def IsValidTag(tag: typing.Optional[str]) -> bool: ...
    @staticmethod
    def IsValidText(text: typing.Optional[str]) -> bool: ...
    def SearchForChildByTag(self, tag: str) -> typing.Optional[SecurityElement]: ...
    def SearchForTextOfTag(self, tag: str) -> typing.Optional[str]: ...
    def ToString(self) -> str: ...


class SecurityException(SystemException):
    @typing.overload
    def __init__(self) -> None: ...
    @typing.overload
    def __init__(self, message: typing.Optional[str]) -> None: ...
    @typing.overload
    def __init__(self, message: typing.Optional[str], inner: typing.Optional[Exception]) -> None: ...
    @typing.overload
    def __init__(self, message: typing.Optional[str], type: typing.Optional[typing.Type[typing.Any]]) -> None: ...
    @typing.overload
    def __init__(self, message: typing.Optional[str], type: typing.Optional[typing.Type[typing.Any]], state: typing.Optional[str]) -> None: ...
    @property
    def Data(self) -> IDictionary: ...
    @property
    def Demanded(self) -> typing.Optional[typing.Any]: ...
    @Demanded.setter
    def Demanded(self, value: typing.Optional[typing.Any]) -> typing.Optional[typing.Any]: ...
    @property
    def DenySetInstance(self) -> typing.Optional[typing.Any]: ...
    @DenySetInstance.setter
    def DenySetInstance(self, value: typing.Optional[typing.Any]) -> typing.Optional[typing.Any]: ...
    @property
    def FailedAssemblyInfo(self) -> typing.Optional[AssemblyName]: ...
    @FailedAssemblyInfo.setter
    def FailedAssemblyInfo(self, value: typing.Optional[AssemblyName]) -> typing.Optional[AssemblyName]: ...
    @property
    def GrantedSet(self) -> typing.Optional[str]: ...
    @GrantedSet.setter
    def GrantedSet(self, value: typing.Optional[str]) -> typing.Optional[str]: ...
    @property
    def HelpLink(self) -> typing.Optional[str]: ...
    @HelpLink.setter
    def HelpLink(self, value: typing.Optional[str]) -> typing.Optional[str]: ...
    @property
    def HResult(self) -> int: ...
    @HResult.setter
    def HResult(self, value: int) -> int: ...
    @property
    def InnerException(self) -> typing.Optional[Exception]: ...
    @property
    def Message(self) -> str: ...
    @property
    def Method(self) -> typing.Optional[MethodInfo]: ...
    @Method.setter
    def Method(self, value: typing.Optional[MethodInfo]) -> typing.Optional[MethodInfo]: ...
    @property
    def PermissionState(self) -> typing.Optional[str]: ...
    @PermissionState.setter
    def PermissionState(self, value: typing.Optional[str]) -> typing.Optional[str]: ...
    @property
    def PermissionType(self) -> typing.Optional[typing.Type[typing.Any]]: ...
    @PermissionType.setter
    def PermissionType(self, value: typing.Optional[typing.Type[typing.Any]]) -> typing.Optional[typing.Type[typing.Any]]: ...
    @property
    def PermitOnlySetInstance(self) -> typing.Optional[typing.Any]: ...
    @PermitOnlySetInstance.setter
    def PermitOnlySetInstance(self, value: typing.Optional[typing.Any]) -> typing.Optional[typing.Any]: ...
    @property
    def RefusedSet(self) -> typing.Optional[str]: ...
    @RefusedSet.setter
    def RefusedSet(self, value: typing.Optional[str]) -> typing.Optional[str]: ...
    @property
    def Source(self) -> typing.Optional[str]: ...
    @Source.setter
    def Source(self, value: typing.Optional[str]) -> typing.Optional[str]: ...
    @property
    def StackTrace(self) -> typing.Optional[str]: ...
    @property
    def TargetSite(self) -> typing.Optional[MethodBase]: ...
    @property
    def Url(self) -> typing.Optional[str]: ...
    @Url.setter
    def Url(self, value: typing.Optional[str]) -> typing.Optional[str]: ...
    def GetObjectData(self, info: SerializationInfo, context: StreamingContext) -> None: ...
    def ToString(self) -> str: ...


class SecurityRulesAttribute(Attribute):
    def __init__(self, ruleSet: SecurityRuleSet) -> None: ...
    @property
    def RuleSet(self) -> SecurityRuleSet: ...
    @property
    def SkipVerificationInFullTrust(self) -> bool: ...
    @SkipVerificationInFullTrust.setter
    def SkipVerificationInFullTrust(self, value: bool) -> bool: ...
    @property
    def TypeId(self) -> typing.Any: ...


class SecurityRuleSet(typing.SupportsInt):
    @typing.overload
    def __init__(self, value : int) -> None: ...
    @typing.overload
    def __init__(self, value : int, force_if_true: bool) -> None: ...
    def __int__(self) -> int: ...
    
    # Values:
    None_ : SecurityRuleSet # 0
    Level1 : SecurityRuleSet # 1
    Level2 : SecurityRuleSet # 2


class SecuritySafeCriticalAttribute(Attribute):
    def __init__(self) -> None: ...
    @property
    def TypeId(self) -> typing.Any: ...


class SecurityTransparentAttribute(Attribute):
    def __init__(self) -> None: ...
    @property
    def TypeId(self) -> typing.Any: ...


class SecurityTreatAsSafeAttribute(Attribute):
    def __init__(self) -> None: ...
    @property
    def TypeId(self) -> typing.Any: ...


class SuppressUnmanagedCodeSecurityAttribute(Attribute):
    def __init__(self) -> None: ...
    @property
    def TypeId(self) -> typing.Any: ...


class UnverifiableCodeAttribute(Attribute):
    def __init__(self) -> None: ...
    @property
    def TypeId(self) -> typing.Any: ...


class VerificationException(SystemException):
    @typing.overload
    def __init__(self) -> None: ...
    @typing.overload
    def __init__(self, message: typing.Optional[str]) -> None: ...
    @typing.overload
    def __init__(self, message: typing.Optional[str], innerException: typing.Optional[Exception]) -> None: ...
    @property
    def Data(self) -> IDictionary: ...
    @property
    def HelpLink(self) -> typing.Optional[str]: ...
    @HelpLink.setter
    def HelpLink(self, value: typing.Optional[str]) -> typing.Optional[str]: ...
    @property
    def HResult(self) -> int: ...
    @HResult.setter
    def HResult(self, value: int) -> int: ...
    @property
    def InnerException(self) -> typing.Optional[Exception]: ...
    @property
    def Message(self) -> str: ...
    @property
    def Source(self) -> typing.Optional[str]: ...
    @Source.setter
    def Source(self, value: typing.Optional[str]) -> typing.Optional[str]: ...
    @property
    def StackTrace(self) -> typing.Optional[str]: ...
    @property
    def TargetSite(self) -> typing.Optional[MethodBase]: ...

